#include <stdio.h>
#include <stdint.h>
#include <dlfcn.h>
#include <stdlib.h>
#include <string.h>
#include "image_decode.h"

//BMP文件头信息
//编译时注意加上-lstdc++
const uint8_t g_bmpHeader[54] = {0x42, 0x4D, 0xCE, 0x97, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x00, 0x00, 0x00, 0x28, 0x00,
								 0x00, 0x00, 0x66, 0x00, 0x00, 0x00, 0x7E, 0x00, 0x00, 0x00, 0x01, 0x00, 0x18, 0x00, 0x00, 0x00,
								 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
								 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
typedef int (*DecodeFunc)(unsigned char* pwlt, unsigned char* pbmp, int n);

static int dk_wlt2bmpBuffer_imp( unsigned char *wltData, unsigned char *imageData, int image_len){
	
	int 			len; // ST1C_4
	char 			*err_msg; // rax
	unsigned int 	err_code; // [rsp+14h] [rbp-96DCh]
	char 			unpack_data[38560]; // [rsp+30h] [rbp-96C0h]
	int 			min_bmp_len; // [rsp+96D0h] [rbp-20h]
	unsigned int 	unpack_code = 0; // [rsp+96D4h] [rbp-1Ch]
	int 			index; // [rsp+96D8h] [rbp-18h]
	int 			i; // [rsp+96DCh] [rbp-14h]
	void 			*glibm_handle = NULL;		  
	len = image_len;
	min_bmp_len = 38862;
	memset(unpack_data, 0, sizeof(unpack_data));
	if ( len >= min_bmp_len ){
		if ( !glibm_handle ){
			glibm_handle = dlopen("libwlt.so", 1);
		}
		if ( glibm_handle ){
			
			DecodeFunc g_unpack = (DecodeFunc)dlsym(glibm_handle, "_Z6unpackPcS_i");
			
			if ( g_unpack ){
				  unpack_code = g_unpack(wltData, (unsigned char *)unpack_data, 310LL);
				  if ( unpack_code == 1 ){
					index = 0;
					i = 0;
					memcpy(imageData, &g_bmpHeader, 0x36uLL);
					index += 54;
					for ( i = 0; i <= 12851; ++i ){
					  imageData[index++] = unpack_data[3 * i + 2];
					  imageData[index++] = unpack_data[3 * i + 1];
					  imageData[index++] = unpack_data[3 * i];
					  if ( !((i + 1) % 102) )
					  {
						imageData[index++] = -1;
						imageData[index++] = -1;
					  }
					}
				  }
				  err_code = unpack_code;
			}
			else{
				dlclose(glibm_handle);
				glibm_handle = 0LL;
				err_code = -101;
			}
		}
		else{
			err_msg = dlerror();
			printf("Open Error:%s.\n", err_msg);
			err_code = -100;
		}
	}
	else
	{
		err_code = -103;
	}
	return err_code;
}

int dk_saveWlt2Bmp(unsigned char *wltBuffer, const char* bmpPath){
	int ret;
	unsigned char *imageData = NULL; //bmp文件buf
	int outLen = (102*3+2)*126+54;

	imageData = (unsigned char*)malloc(outLen);
	ret = dk_wlt2bmpBuffer_imp( wltBuffer, imageData, outLen);
	
	if(ret == 1){
		FILE *fpWrite = NULL;
		fpWrite = fopen(bmpPath, "wb");
		if (NULL != fpWrite)
		{
			fwrite(imageData, 1, outLen,  fpWrite);
			fclose(fpWrite);		
		}
		else
		{
			printf("bmp create file fail\n");
		}
	}
	free(imageData);
	return ret;
}

