#ifndef USB_HID_H_
#define USB_HID_H_
#include "stdint.h"
#include "libusb.h"

#ifdef __cplusplus
extern "C" {
#endif

#define FrameMaxLen  64
#define VendorId     1155
#define ProductId    22315

typedef enum{
	libusb_error,
	LIBUSB_ERROR_UNNIT = -13,			//设备未初始化
	LIBUSB_ERROR_BUFFER_EMPTY = -14,	//数组为空
	LIBUSB_ERROR_BUFFER_OVER = -15,		//数组长度大于64
	LIBUSB_ERROR_DATA_ERROR = -16,		//数据格式错误
}user_libusb_error;

#define FRAME_OF_HEAD               "\xAA\xAA\xAA\x96\x69"
#define FRAME_OF_HEAD_LEN           5
#define FRAME_OF_CMD_LEN            2
#define FRAME_OF_LENS               2
#define FRAME_OF_ADDR_LEN           1
#define FRAME_OF_RESP_LEN           3
#define FRAME_OF_DATA
#define FRAME_OF_LRC_LEN            1

int hid_comm_init(void);
int hid_get_data(uint8_t *data, uint16_t *len, uint16_t timeout);
int sendDataLen(uint8_t *data, uint8_t data_len, uint16_t timeout);
int hid_comm_deinit(void) ;

#ifdef __cplusplus
}
#endif


#endif

