#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include "Reader.h"
#include "stdint.h"
#include <stddef.h>
#include <stdlib.h>

#include "ComByteManager.h"
#include "al_cpu_apdu.h"
#include "dk_utils.h"
#include "sdk_config.h"
#include "al_cpu_apdu.h"
#include "al_mifare_one.h"
#include "YCTCard.h"
#include "cJSON.h"
#include "al_mifare_one.h"

uint8_t cmd1[] = {0x00,0xA4,0x04,0x00,0x08,0x59,0x43,0x54,0x2E,0x55,0x53,0x45,0x52};
uint8_t cmd2[] = {0x00,0xA4,0x04,0x00,0x08,0x50,0x41,0x59,0x2E,0x41,0x50,0x50,0x59};
uint8_t cmd3[] = {0xC4,0xFE,0x00,0x00,0x00};
uint8_t cmd4[] = {0x00,0xA4,0x00,0x00,0x02,0xDD,0xF1};
uint8_t cmd5[] = {0x00,0xB0,0x95,0x00,0x00};
uint8_t cmd6[] = {0x00,0xA4,0x00,0x00,0x02,0xAD,0xF3};
uint8_t cmd7[] = {0x00,0x20,0x00,0x00,0x03,0x12,0x34,0x56};
uint8_t cmd8[] = {0x80,0x50,0x00,0x02,0x0B,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
uint8_t cmd9[] = {0x00,0xa4,0x04,0x00,0x0f,0x73,0x78,0x31,0x2E,0x73,0x68,0x2E,0xC9,0xE7,0xBB,0xE1,0xB1,0xA3,0xD5,0xCF};
uint8_t cmd10[] = {0x00,0xa4,0x02,0x00,0x02,0xEF,0x05,0x00};
uint8_t cmd11[] = {0x00,0xb2,0x01,0x00,0x00};
uint8_t cmd12[] = {0x00,0xb2,0x07,0x00,0x00};
uint8_t extern_SIN_Card_cmd[] = {0x00, 0xA4, 0x00, 0x00, 0x02, 0x3F, 0x00};

//获取羊城通CPU卡数据 1:获取成功， 0:获取失败,获取当前系统当前时间未实现，需要自己添加
int getYctCPUCardInfo(char *YCT_json_str){
	int 		ret = 0;
	uint8_t 	data[256] ={0};
	uint16_t 	data_len = 0;
	char 		str_data[512] ={0};
	char 		timestr[32] = {0};
	
	cJSON *data_obj = cJSON_CreateObject();
	cJSON *root = cJSON_CreateObject();
//	char  *json_data_out = NULL;
	char  *out = NULL;
	char errcode[7] = {"000000"};
	char errmsg[] = {"STATE_CARD_GOTO_OUT"};
	
	//数据交换
	ret = al_apdu_com_exchange(APDU_COM, cmd1, sizeof(cmd1), data, &data_len);

	//非9000，执行第2条,社保卡
	if(ret != 0 || data[data_len-2] !=0x90 || data[data_len-1] ==0x00){
		
		ret = al_apdu_com_exchange(APDU_COM, cmd2, sizeof(cmd2), data, &data_len);
		dk_log_hex("<---", data, data_len );
	
		//非9000，执行第9条
		if(ret != 0 || data[data_len-2] !=0x90 || data[data_len-1] !=0x00){
			ret = al_apdu_com_exchange(APDU_COM, cmd9, sizeof(cmd9), data, &data_len);
			
				//这条命令不用管回复
			ret = al_apdu_com_exchange(APDU_COM, extern_SIN_Card_cmd, sizeof(extern_SIN_Card_cmd), data, &data_len);
			
			//非9000，退出
			if(ret != 0 || data[data_len-2] !=0x90 || data[data_len-1] !=0x00){
				memcpy(errcode,"100122", strlen("100122"));
                memcpy(errmsg,"STATE_CARD_GOTO_OUT", strlen("STATE_CARD_GOTO_OUT"));
				goto free_and_return;
			}

			ret = al_apdu_com_exchange(APDU_COM, cmd10, sizeof(cmd10), data, &data_len);

			//非9000，退出
			if(ret != 0 || data[data_len-2] !=0x90 || data[data_len-1] !=0x00){
				memcpy(errcode,"100122", strlen("100122"));
                memcpy(errmsg,"STATE_CARD_GOTO_OUT", strlen("STATE_CARD_GOTO_OUT"));
				goto  free_and_return;
			}

			DEBUG_Printf("指令11-发送：00b2010000\r\n");
			ret = al_apdu_com_exchange(APDU_COM, cmd11, sizeof(cmd11), data, &data_len);

			//非9000，退出
			if(ret != 0 || data[data_len-2] !=0x90 || data[data_len-1] !=0x00){
				memcpy(errcode,"100123", strlen("100123"));
                memcpy(errmsg,"STATE_CARD_GOTO_OUT", strlen("STATE_CARD_GOTO_OUT"));
				goto  free_and_return;
			}
			dk_log_hex("指令11-返回", data, data_len);
			byteHexToSting(data, data_len, str_data);

			cJSON_AddStringToObject(data_obj, "aaz501", str_data);

			DEBUG_Printf("指令12-发送：00b2070000\r\n");
			ret = al_apdu_com_exchange(APDU_COM, cmd12, sizeof(cmd12), data, &data_len);
		
			//非9000，退出
			if(ret != 0 || data[data_len-2] !=0x90 || data[data_len-1] !=0x00){
				memcpy(errcode,"100123", strlen("100123"));
                memcpy(errmsg,"STATE_CARD_GOTO_OUT", strlen("STATE_CARD_GOTO_OUT"));
				goto free_and_return;
			}
			dk_log_hex("指令12-返回", data, data_len);
			byteHexToSting(data, data_len, str_data);
			cJSON_AddStringToObject(data_obj, "aaz500", str_data);
			
			cJSON_AddStringToObject(data_obj, "cardtype", "3");
			
			cJSON_AddStringToObject(root, "errcode", errcode);
			errmsg[0] = '\0';
			cJSON_AddStringToObject(root, "errmsg", errmsg);
			cJSON_AddItemToObject(root, "data", data_obj);

			out = cJSON_Print(root);
			DEBUG_Printf("%s\n", out);
			goto free_and_return ;
		}
		
	}

	DEBUG_Printf("指令3-发送：C4FE000000\r\n");
	ret = al_apdu_com_exchange(APDU_COM, cmd3, sizeof(cmd3), data, &data_len);
	
	//非9000
	if(ret != 0 || data[data_len-2] !=0x90 || data[data_len-1] !=0x00){
		memcpy(errcode,"100123", strlen("100123"));
        memcpy(errmsg,"STATE_CARD_GOTO_OUT", strlen("STATE_CARD_GOTO_OUT"));
		goto  free_and_return;
	}
	if(data_len < 9){
		memcpy(errcode,"100123", strlen("100123"));
        memcpy(errmsg,"STATE_CARD_GOTO_OUT", strlen("STATE_CARD_GOTO_OUT"));
		goto  free_and_return;
	}
	byteHexToSting(data, 8, str_data);
	cJSON_AddStringToObject(data_obj, "fno", str_data);
	

	DEBUG_Printf("指令4-发送：00A4000002DDF1\r\n");
	ret = al_apdu_com_exchange(APDU_COM, cmd4, sizeof(cmd4), data, &data_len);
	
	//非9000
	if(ret != 0 || data[data_len-2] !=0x90 || data[data_len-1] !=0x00){
		memcpy(errcode,"100124", strlen("100124"));
        memcpy(errmsg,"STATE_CARD_GOTO_OUT", strlen("STATE_CARD_GOTO_OUT"));
		goto  free_and_return;
	}
	DEBUG_Printf("指令5-发送：00B0950000\r\n");
	ret = al_apdu_com_exchange(APDU_COM, cmd5, sizeof(cmd5), data, &data_len);
	
	//非9000
	if(ret != 0 || data[data_len-2] !=0x90 || data[data_len-1] !=0x00){
		memcpy(errcode,"100125", strlen("100125"));
        memcpy(errmsg,"STATE_CARD_GOTO_OUT", strlen("STATE_CARD_GOTO_OUT"));
		goto  free_and_return;
	}
	if(data_len < 61){
		memcpy(errcode,"100125", strlen("100125"));
        memcpy(errmsg,"STATE_CARD_GOTO_OUT", strlen("STATE_CARD_GOTO_OUT"));
		goto  free_and_return;
	}
	
	byteHexToSting(data+8, 8, str_data);
	cJSON_AddStringToObject(data_obj, "lno", str_data);

	byteHexToSting(data+49, 1, str_data);
	cJSON_AddStringToObject(data_obj, "city", str_data);

	byteHexToSting(data+58, 2, str_data);
	cJSON_AddStringToObject(data_obj, "specardtype", str_data);
	cJSON_AddStringToObject(data_obj, "lno", str_data);

	DEBUG_Printf("指令6-发送：00A4000002ADF3\r\n");
	ret = al_apdu_com_exchange(APDU_COM, cmd6, sizeof(cmd6), data, &data_len);
	
	//非9000
	if(ret != 0 || data[data_len-2] !=0x90 || data[data_len-1] !=0x00){
		memcpy(errcode,"100126", strlen("100126"));
        memcpy(errmsg,"STATE_CARD_GOTO_OUT", strlen("STATE_CARD_GOTO_OUT"));
		goto  free_and_return;
	}

	DEBUG_Printf("指令7-发送：0020000003123456\r\n");
	ret = al_apdu_com_exchange(APDU_COM, cmd7, sizeof(cmd7), data, &data_len);
	
	//非9000
	if(ret != 0 || data[data_len-2] !=0x90 || data[data_len-1] !=0x00){
		memcpy(errcode,"100127", strlen("100127"));
        memcpy(errmsg,"STATE_CARD_GOTO_OUT", strlen("STATE_CARD_GOTO_OUT"));
		goto  free_and_return;
	}

	DEBUG_Printf("指令8-发送：805000020B0100000000000000000000\r\n");
	ret = al_apdu_com_exchange(APDU_COM, cmd8, sizeof(cmd8), data, &data_len);
	
	//非9000
	if(ret != 0 || data[data_len-2] !=0x90 || data[data_len-1] !=0x00){
		memcpy(errcode,"100128", strlen("100128"));
        memcpy(errmsg,"STATE_CARD_GOTO_OUT", strlen("STATE_CARD_GOTO_OUT"));
		goto  free_and_return;
	}
	if(data_len < 2){
		memcpy(errcode,"100128", strlen("100128"));
        memcpy(errmsg,"STATE_CARD_GOTO_OUT", strlen("STATE_CARD_GOTO_OUT"));
		goto  free_and_return;
	}
	byteHexToSting(data, data_len - 2, str_data);
	DEBUG_Printf("str_data  %s\r\n", str_data);
	cJSON_AddStringToObject(data_obj, "traninfo", str_data);
	cJSON_AddStringToObject(data_obj, "cardtype", "2");
	cJSON_AddStringToObject(data_obj, "amount", "00000000");

	//注意需要取当前日期
	get_sys_time(timestr);
	cJSON_AddStringToObject(data_obj, "trantime", timestr);

	cJSON_AddStringToObject(root, "errcode", errcode);
	errmsg[0] = '\0';
	cJSON_AddStringToObject(root, "errmsg", errmsg);
	cJSON_AddItemToObject(root, "data", data_obj);
	out = cJSON_Print(root);
	DEBUG_Printf("%s\n", out);

	
free_and_return:

	//未获取成功	
	if(out == NULL){
		cJSON_AddStringToObject(root, "errcode", errcode);
		cJSON_AddStringToObject(root, "errmsg", errmsg);
		cJSON_AddStringToObject(root, "data", "");
		out = cJSON_Print(root);
		ret = 0;
	}
	
	//获取成功
	else{
		ret = 1;
	}
	
	cJSON_Delete(root);

	memcpy(YCT_json_str, out, strlen(out));
	YCT_json_str[strlen(out)] = '\0';

	if(out != NULL){
    	free(out);
	}

	return ret;
}

//获取羊城通M1卡数据 1:获取成功， 0:获取失败
int getYctMifareCardInfo(uint8_t *uid, char *YCT_json_str){
	int 		ret = 0;
	uint8_t		cnt = 0;
	char 		info_str[32] = {0};
	uint8_t 	read_block_data[16] ={0};
	uint16_t 	read_data_len = 0;
	char 		str_data[512] ={0};
	uint8_t 	key[2][6] = {{0xEE, 0x9B, 0xD3, 0x61, 0xB0, 0x1B},
								{0xE2, 0xEB, 0x2C, 0x59, 0xA3, 0xD6}};
	

	cJSON 	*data_obj = cJSON_CreateObject();
	cJSON 	*root = cJSON_CreateObject();
	char  	*out = NULL;
	char 	errcode[7] = {"000000"};
	char 	errmsg[] = {"STATE_CARD_GOTO_OUT"};

	cJSON_AddStringToObject(data_obj, "cardtype", "1");
	cJSON_AddStringToObject(data_obj, "city", "00");

	byteHexToSting(uid, 4, str_data);
	cJSON_AddStringToObject(data_obj, "fno", str_data);
	cJSON_AddStringToObject(data_obj, "specardtype", "");

	
	cJSON_AddStringToObject(root, "errcode", errcode);
	errmsg[0] = '\0';
	cJSON_AddStringToObject(root, "errmsg", errmsg);
	
	do{
		al_mifare_key_auth(0x04, 1, (uint8_t *)key[cnt], uid);
		ret = al_mifare_read_block(0x04, read_block_data);
	}while(ret != 0 && cnt++ < 2);

	if(ret != 0){
		memcpy(errcode,"100121", strlen("100121"));
        memcpy(errmsg,"ERRO_CARD_M1_READ_TAG", strlen("ERRO_CARD_M1_READ_TAG"));
		goto free_and_return;
	}
	dk_log_hex("block 4 data:", read_block_data, 16);

	byteHexToSting(read_block_data, 4, info_str);
	byteHexToSting(read_block_data + 5, 4, info_str + 8);
	cJSON_AddStringToObject(data_obj, "lno", info_str);
	
	cJSON_AddItemToObject(root, "data", data_obj);
	out = cJSON_Print(root);
	DEBUG_Printf("%s\n", out);
	goto free_and_return ;
	
free_and_return:

	//未获取成功	
	if(out == NULL){
		cJSON_AddStringToObject(root, "errcode", errcode);
		cJSON_AddStringToObject(root, "errmsg", errmsg);
		cJSON_AddStringToObject(root, "data", "");
		out = cJSON_Print(root);
		ret = 0;
	}
	
	//获取成功
	else{
		ret = 1;
	}
	
	cJSON_Delete(root);

	memcpy(YCT_json_str, out, strlen(out));
	YCT_json_str[strlen(out)] = '\0';

	if(out != NULL){
    	free(out);
	}
	return ret;
}







