#include <stddef.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/time.h>
#include "dk_utils.h"
#include "stdio.h"
#include "sdk_config.h"


void print_hex(const char *title, const unsigned char buf[], size_t len) {
	printf("%s: ", title);

	for (size_t i = 0; i < len; i++)
		printf("%02x", buf[i]);

	printf("\r\n");
}

#define TIME_COUNT 1

#ifdef TIME_COUNT
void system_time_printf(void) {
	char buf[32] = {0};
	struct timeval tv;
	struct tm      tm;
	size_t         len= 28;
			
	memset(&tv, 0, sizeof(tv));
	memset(&tm, 0, sizeof(tm));
	gettimeofday(&tv, NULL);
	localtime_r(&tv.tv_sec, &tm);
	strftime(buf, len, "%Y-%m-%d %H:%M:%S", &tm);
	len = strlen(buf);
	sprintf(buf + len, ".%-6.3d", (int)(tv.tv_usec/1000)); 
	printf("%s\r\n", buf);
}

#else 
#define system_time_printf(...)
#endif 

void get_sys_time(char *timestr) {
	char buf[32] = {0};
	struct timeval tv;
	struct tm      tm;
	size_t         len= 28;
			
	memset(&tv, 0, sizeof(tv));
	memset(&tm, 0, sizeof(tm));
	gettimeofday(&tv, NULL);
	localtime_r(&tv.tv_sec, &tm);
	strftime(buf, len, "%Y%m%d%H%M%S", &tm);
	len = strlen(buf);
	buf[len] = '\0';
	//sprintf(buf + len, ".%-6.3d", (int)(tv.tv_usec/1000)); 
	printf("%s\r\n", buf);
	memcpy(timestr, buf, len);
}


long get_timestamp(void){
	 struct timeval stamp;
     gettimeofday(&stamp, NULL);
	 return stamp.tv_sec;
}

void get_timestamp_str(char *timestamp_str) {
	int timestamp = 0;
	char cur_time_str[32] = {0};
	
	struct timeval tv;	
	memset(&tv, 0, sizeof(tv));
	gettimeofday(&tv, NULL);
	printf("%ld\r\n",tv.tv_sec);
	timestamp = tv.tv_sec;// - 8 *60 *60;
	
	sprintf(cur_time_str, "%d", timestamp);
	memcpy(timestamp_str, cur_time_str, strlen(cur_time_str));
}


void Sleep(int ms) {
	struct timeval delay;
	delay.tv_sec = 0;
	delay.tv_usec = ms * 1000;
	select(0, NULL, NULL, NULL, &delay);
}

char char_ascii[] = "0123456789abcdef";
void byteHexToSting(uint8_t *hex, uint16_t hex_len, char *hex_str) {
	uint16_t i = 0;
	for( i = 0; i < hex_len; i++) {
		hex_str[2*i] =char_ascii[(hex[i]&0xf0) >> 4] ;
		hex_str[2*i +1] = char_ascii[(hex[i]&0x0f)];
	}
	hex_str[2*i] = '\0' ;

}

//异或校验
int calc_lrc(uint8_t *in_data, int len) {
	unsigned char lrc;

	if (in_data == NULL || len <= 0)
		return 0;
	lrc = 0;
	while (len-- > 0) {
		lrc ^= *in_data++;
	}
	return lrc;
}
